
/*  -*- MaTX -*-
 *
 *  yOz
 *      diff() - 
 *
 *  y`z
 *      Y = diff(X)
 *         Matrix C;
 *         Matrix X;
 *
 *      Y = diff(X,k)
 *         Matrix Y;
 *         Matrix X;
 *         Integer k;
 *
 *  y@\z
 *      xNg X ɂĂāCdiff(X)́CאڐƂ̍𐬕Ƃ
 *      xNg
 *      
 *          Y = X(2:length(X)) - X(1:length(x)-1)
 *
 *      ߂BxNg Y ̒̓xNg X ̒ 1 
 *      ȂȂBdiff(X,k) ́Ck K߂B
 *
 *          diff(X,k) = diff(diff(X,n-1))
 *
 *  yz
 *      >> Y = diff([1 2 3 4 5]) 
 *      === [Y] : (  1,  4) ===
 *                 (  1)         (  2)         (  3)         (  4)     
 *      (  1)  1.000000E+00  1.000000E+00  1.000000E+00  1.000000E+00
 *
 *  y֘Aځz
 *      diff_row, diff_col
 *
 *   ------------------------------------------------------------------------
 *
 *  yOz
 *      diff_col() - 񖈂̍
 *
 *  y`z
 *      Y = diff_col(X)
 *         Matrix C;
 *         Matrix X;
 *
 *      Y = diff_col(X,k)
 *         Matrix Y;
 *         Matrix X;
 *         Integer k;
 *
 *  y@\z
 *      X xNĝƂCdiff_col(X)́CאڐƂ̍𐬕Ƃ
 *      xNg
 *      
 *          Y = X(2:length(X)) - X(1:length(x)-1)
 *
 *      ߂BxNg Y ̒̓xNg X ̒ 1 
 *      ȂȂBdiff_col(X,k) ́Ck K߂B
 *
 *          diff_col(X,k) = diff_col(diff_col(X,n-1))
 *
 *      X ŝƂCY = diff_col(X) ́CX ̗񖈂ɍ߂B
 *      s Y ̍s̐́Cs X ̍s̐ 1 ȂB
 *
 *  yz
 *      >> C = diff_col([1 2 3 4 5])
 *      === [C] : (  1,  4) ===
 *                 (  1)         (  2)         (  3)         (  4)     
 *      (  1)  1.000000E+00  1.000000E+00  1.000000E+00  1.000000E+00
 *
 *      >> C = diff_col([[2 3 1 4][10 9 7 8]])
 *      === [C] : (  1,  4) ===
 *                 (  1)         (  2)         (  3)         (  4)     
 *      (  1)  8.000000E+00  6.000000E+00  6.000000E+00  4.000000E+00
 *
 *  y֘Aځz
 *      diff, diff_row
 *
 *   ------------------------------------------------------------------------
 *
 *  yOz
 *      diff_row() - s̍
 *
 *  y`z
 *      Y = diff_row(X)
 *         Matrix C;
 *         Matrix X;
 *
 *      Y = diff_row(X,k)
 *         Matrix Y;
 *         Matrix X;
 *         Integer k;
 *
 *  y@\z
 *      X xNĝƂCdiff_row(X)́CאڐƂ̍𐬕Ƃ
 *      xNg
 *      
 *          Y = X(2:length(X)) - X(1:length(x)-1)
 *
 *      ߂BxNg Y ̒̓xNg X ̒ 1 
 *      ȂȂBdiff_row(X,k) ́Ck K߂B
 *
 *          diff_row(X,k) = diff_row(diff_row(X,n-1))
 *
 *      X ŝƂCY = diff_row(X) ́CX ̍sɍ߂B
 *      s Y ̗̐́Cs X ̗̐ 1 ȂB
 *
 *  yz
 *      >> C = diff_row([1 2 3 4 5])
 *      === [C] : (  1,  4) ===
 *                 (  1)         (  2)         (  3)         (  4)     
 *      (  1)  1.000000E+00  1.000000E+00  1.000000E+00  1.000000E+00
 *
 *      >> C = diff_row([[2 3 1 4 5][10 9 7 8 6]])
 *      === [C] : (  2,  4) ===
 *                 (  1)         (  2)         (  3)         (  4)     
 *      (  1)  1.000000E+00 -2.000000E+00  3.000000E+00  1.000000E+00
 *      (  2) -1.000000E+00 -2.000000E+00  1.000000E+00 -2.000000E+00
 *
 *  y֘Aځz
 *      diff, diff_col
 */

Func Matrix diff(x, k, ...)
	Matrix x;
	Integer k;
{
	Matrix y;

	error(nargchk(1, 2, nargs, "diff"));
	
	if (nargs == 1) {
		if (Rows(x) == 1 || Cols(x) == 1) {
			return diff_col(x);
		} else {
			error("diff(): xNgłȂB\n");
		}
	} else {
		if (Rows(x) == 1 || Cols(x) == 1) {
			return diff_col(x, k);
		} else {
			error("diff(): xNgłȂB\n");
		}
	}
}

Func Matrix diff_col(x_, k, ...)
	Matrix x_;
	Integer k;
{
	Matrix x;
	Integer i,m,n;

	error(nargchk(1, 2, nargs, "diff_col"));

	x = x_;

	if (nargs == 1) {
		k = 1;
	}
	for (i = 1; i <= k; i++) {
		{m,n} = size(x);
		if (m == 1) {
			x = x(2:n) - x(1:n-1);
		} else {
			x = x(2:m,:) - x(1:m-1,:);
		}
	}
	return x;
}

Func Matrix diff_row(x, k, ...)
	Matrix x;
	Integer k;
{
	error(nargchk(1, 2, nargs, "diff_row"));
	
	if (nargs == 1) {
		return trans(diff_col(trans(x)));
	} else {
		return trans(diff_col(trans(x), k));
	}
}
