
/*  -*- MaTX -*-
 *
 *  yOz
 *      hist() - qXgO
 *
 *  y`z
 *      {N,X} = hist(Y)
 *         Array N,X;
 *         Array Y;
 *
 *      {N,X} = hist(Y,k)
 *         Array N,X;
 *         Array Y;
 *         Integer k;
 *
 *  y@\z
 *      {N,X} = hist(Y)́CY ̑SẴf[^̍ŏlƍől̊Ԃ 10
 *      C̃qXgO\邽߂ɕKvȕpx N Ƃ̈ʒu
 *      xNg X ԂBꂽ X  N gāCbarp(X,N) 
 *      qXgOvbgłBhist(Y,k) ͍ŏlƍől̊Ԃ
 *      k B
 * 
 *  yz
 *      Kzf[^̃qXgOB
 *
 *      >> Y = randn(1,1000);
 *      >> {N,X} = hist(Y,40);
 *      >> barp(X,N)
 *
 *  y֘Aځz
 *      hist_row, hist_col, bar, barp
 *
 *   ------------------------------------------------------------------------
 *
 *  yOz
 *      hist_col() - 񖈂̃qXgO
 *
 *  y`z
 *      {N,X} = hist_col(Y)
 *         Array N,X;
 *         Array Y;
 *
 *      {N,X} = hist_col(Y,k)
 *         Array N,X;
 *         Array Y;
 *         Integer k;
 *
 *  y@\z
 *      {N,X} = hist_col(Y)́CxNg Y f[^̍ŏlƍől̊Ԃ 10
 *      C̃qXgO\邽߂ɕKvȕpx N Ƃ̈ʒu
 *      xNg X ԂBꂽ X  N gāCbarp(X,N) 
 *      qXgOvbgłBhist_col(Y,k) ͍ŏlƍől̊Ԃ
 *      k B
 * 
 *      Y ŝƂC񖈂ɃqXgO\邽߂ɕKvȕpx N 
 *      Ƃ̈ʒu X ԂBs X  N ̑ΉgāC
 *      barp(X(:,i),N(:,i)) ŃqXgOvbgłB
 *
 *  yz
 *      Kzf[^̃qXgOB
 *
 *      >> Y = randn(1000,2);
 *      >> {N,X} = hist_col(Y,40);
 *      >> barp(X(:,1),N(:,1));
 *
 *  y֘Aځz
 *      hist, hist_row, bar, barp
 *
 *   ------------------------------------------------------------------------
 *
 *  yOz
 *      hist_row() - s̃qXgO
 *
 *  y`z
 *      {N,X} = hist_row(Y)
 *         Array N,X;
 *         Array Y;
 *
 *      {N,X} = hist_row(Y,k)
 *         Array N,X;
 *         Array Y;
 *         Integer k;
 *
 *  y@\z
 *      {N,X} = hist_row(Y)́CxNg Y f[^̍ŏlƍől̊Ԃ 10
 *      C̃qXgO\邽߂ɕKvȕpx N Ƃ̈ʒu
 *      xNg X ԂBꂽ X  N gāCbarp(X,N) 
 *      qXgOvbgłBhist_row(Y,k) ͍ŏlƍől̊Ԃ
 *      k B
 * 
 *      Y ŝƂCsɃqXgO\邽߂ɕKvȕpx N 
 *      Ƃ̈ʒu X ԂBs X  N ̑ΉsgāC
 *      barp(X(i,:),N(i,:)) ŃqXgOvbgłB
 *
 *  yz
 *      Kzf[^̃qXgOB
 *
 *      >> Y = randn(2,1000);
 *      >> {N,X} = hist_row(Y,40);
 *      >> barp(X(1,:),N(1,:));
 *
 *  y֘Aځz
 *      hist, hist_col, bar, barp
 */

Func List hist(Y, n, ...)
	Array Y;
	Integer n;
{
	error(nargchk(1, 2, nargs, "hist"));
	
	if (nargs == 1) {
		return hist_row(reshape(Y, 1, Rows(Y)*Cols(Y)));
	} else {
		return hist_row(reshape(Y, 1, Rows(Y)*Cols(Y)), n);
	}
}

Func List hist_col(Y_, n, ...)
	Array Y_;
	Integer n;
{
	Integer i,j;
	Array y,nn,x,xx,N,X,Y;
	Real y_max, y_min, bw;
	
	error(nargchk(1, 2, nargs, "hist_col"));

	if (nargs == 1) {
		n = 10;
	}
	
	if (Rows(Y_) == 1 && Cols(Y_) != 1) {
		Y = makecolv(Y_);
	} else {
		Y = Y_;
	}

	X = N = Z(n,Cols(Y));
	for (i = 1; i <= Cols(Y); i++) {
		y = Y(:,i);

		y_min = min(y);
		y_max = max(y);
		bw = (y_max - y_min)/n;
		x = trans(y_min .+ bw*[0:n]);
		x(length(x)) = y_max;

		nn = Z(n+1,1);
		for (j = 2; j <= n + 1; j++) {
			nn(j,1) = length(find(y <= x(j)));
		}

		N(:,i) = nn(2:n+1,1) - nn(1:n,1);
		X(:,i) = x(1:length(x)-1) .+ bw/2;
	}

	if (Rows(Y_) == 1 && Cols(Y_) != 1) {
		N = trans(N);
		X = trans(X);
	}

	return {N, X};
}

Func List hist_row(Y, n, ...)
	Array Y;
	Integer n;
{
	Array N, X;

	error(nargchk(1, 2, nargs, "hist_row"));
	
	if (nargs == 1) {
		{N, X} = hist_col(trans(Matrix(Y)));
	} else {
		{N, X} = hist_col(trans(Matrix(Y)), n);
	}
	N = trans(Matrix(N));
	X = trans(Matrix(X));
	return {N, X};
}
